Package org.eclipse.emf.spi.cdo

## Class DefaultCDOMerger.PerFeature

- java.lang.Object
- - org.eclipse.emf.spi.cdo.DefaultCDOMerger
  - - org.eclipse.emf.spi.cdo.DefaultCDOMerger.PerFeature

- All Implemented Interfaces:
    `CDOMerger`
  Direct Known Subclasses:
    `DefaultCDOMerger.PerFeature.ManyValued`, `DefaultCDOMerger.PerFeature.ManyValuedOld`
  Enclosing class:
    DefaultCDOMerger

      public static class DefaultCDOMerger.PerFeature
      extends DefaultCDOMerger

  If the meaning of this type isn't clear, there really should be more of a description here...
  Author:
    Eike Stepper

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `static class` | `DefaultCDOMerger.PerFeature.ManyValued` | If the meaning of this type isn't clear, there really should be more of a description here...
    `static class` | `DefaultCDOMerger.PerFeature.ManyValuedOld` | If the meaning of this type isn't clear, there really should be more of a description here...

    - ### Nested classes/interfaces inherited from class org.eclipse.emf.spi.cdo.DefaultCDOMerger

      `DefaultCDOMerger.ChangedInSourceAndDetachedInTargetConflict, DefaultCDOMerger.ChangedInSourceAndTargetConflict, DefaultCDOMerger.ChangedInTargetAndDetachedInSourceConflict, DefaultCDOMerger.Conflict, DefaultCDOMerger.PerFeature, DefaultCDOMerger.ResolutionPreference`

    - ### Nested classes/interfaces inherited from interface org.eclipse.emf.cdo.transaction.CDOMerger

      `CDOMerger.ConflictException`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `PerFeature()` |
    `PerFeature​(DefaultCDOMerger.ResolutionPreference resolutionPreference)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected CDOFeatureDelta` | `changedInSource​(CDOFeatureDelta featureDelta)` |
    `protected CDOFeatureDelta` | `changedInSourceAndTarget​(CDOFeatureDelta targetFeatureDelta, CDOFeatureDelta sourceFeatureDelta)` |
    `protected java.lang.Object` | `changedInSourceAndTarget​(CDORevisionDelta targetDelta, CDORevisionDelta sourceDelta)` |
    `protected CDOFeatureDelta` | `changedInSourceAndTargetManyValued​(org.eclipse.emf.ecore.EStructuralFeature feature, CDOFeatureDelta targetFeatureDelta, CDOFeatureDelta sourceFeatureDelta)` |
    `protected CDOFeatureDelta` | `changedInSourceAndTargetSingleValued​(org.eclipse.emf.ecore.EStructuralFeature feature, CDOFeatureDelta targetFeatureDelta, CDOFeatureDelta sourceFeatureDelta)` |
    `protected CDOFeatureDelta` | `changedInTarget​(CDOFeatureDelta featureDelta)` |

    - ### Methods inherited from class org.eclipse.emf.spi.cdo.DefaultCDOMerger

      `addedInSource, addedInSourceAndTarget, addedInTarget, changedInSource, changedInSourceAndDetachedInTarget, changedInTarget, changedInTargetAndDetachedInSource, detachedInSource, detachedInSourceAndTarget, detachedInTarget, getConflicts, getListOrdering, getResolutionPreference, getResult, getSourceMap, getTargetMap, merge, merge`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### PerFeature

          public PerFeature()

    - #### PerFeature

          public PerFeature​(DefaultCDOMerger.ResolutionPreference resolutionPreference)

      Since:
        4.2

  - ### Method Detail

    - #### changedInSourceAndTarget

          protected java.lang.Object changedInSourceAndTarget​(CDORevisionDelta targetDelta,
                                                              CDORevisionDelta sourceDelta)

      Overrides:
        `changedInSourceAndTarget` in class `DefaultCDOMerger`

    - #### changedInTarget

          protected CDOFeatureDelta changedInTarget​(CDOFeatureDelta featureDelta)

      Returns:
        the result feature delta, or `null` to ignore the change.

    - #### changedInSource

          protected CDOFeatureDelta changedInSource​(CDOFeatureDelta featureDelta)

      Returns:
        the result feature delta, or `null` to ignore the change.

    - #### changedInSourceAndTarget

          protected CDOFeatureDelta changedInSourceAndTarget​(CDOFeatureDelta targetFeatureDelta,
                                                             CDOFeatureDelta sourceFeatureDelta)

      Returns:
        the result feature delta, or `null` to indicate an unresolved conflict.

    - #### changedInSourceAndTargetManyValued

          protected CDOFeatureDelta changedInSourceAndTargetManyValued​(org.eclipse.emf.ecore.EStructuralFeature feature,
                                                                       CDOFeatureDelta targetFeatureDelta,
                                                                       CDOFeatureDelta sourceFeatureDelta)

      Returns:
        the result feature delta, or `null` to indicate an unresolved conflict.

    - #### changedInSourceAndTargetSingleValued

          protected CDOFeatureDelta changedInSourceAndTargetSingleValued​(org.eclipse.emf.ecore.EStructuralFeature feature,
                                                                         CDOFeatureDelta targetFeatureDelta,
                                                                         CDOFeatureDelta sourceFeatureDelta)

      Returns:
        the result feature delta, or `null` to indicate an unresolved conflict.